using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace CustomCellTest
{
    [Serializable()]
    public class CustomCellType1 : FarPoint.Win.Spread.CellType.NumberCellType
    {
        FarPoint.Win.Spread.CellType.GeneralEditor ge;

        protected CustomCellType1(System.Runtime.Serialization.SerializationInfo info, System.Runtime.Serialization.StreamingContext context)
            : base(info, context)
        {
            // Is this the method called during the paste?
        }

        public CustomCellType1()
        {
            MaximumValue = 99999999999999D;
            FixedPoint = false;
        }

        public override void GetObjectData(System.Runtime.Serialization.SerializationInfo si, System.Runtime.Serialization.StreamingContext sc)
        {
            //This is the method called during the copy
            base.GetObjectData(si, sc);
        }

        public override string Format(object obj)
        {
            if (obj is decimal)
            {
                return ((decimal)obj).ToString("N6");
            }
            else
            {
                return base.Format(obj);
            }
        }

        public override object Parse(string s)
        {
            decimal o;
            if (decimal.TryParse(s, out o))
            {
                return o;
            }
            else
            {
                return base.Parse(s);
            }
        }

        public override Control GetEditorControl(FarPoint.Win.Spread.Appearance appearance, float zoomFactor)
        {
            ge = (FarPoint.Win.Spread.CellType.GeneralEditor)base.GetEditorControl(appearance, zoomFactor);
            ge.Formatter = null;
            return ge;
        }

        public override object GetEditorValue()
        {
            object retVal = null;

            if (ge.Value != null)
            {
                decimal temp;
                if (decimal.TryParse(ge.Value.ToString(), out temp))
                {
                    retVal = temp;
                }
            }

            return retVal;
        }
    }
}
